// reward 2016
// loovee @ 2016-1-11
#include <Adafruit_NeoPixel.h>
#include <Wire.h>
#include <SparkFunMiniMoto.h>
#include "Hercules_Stepper.h"
#include "JointV2.h"

// PARAMETER
#define MOTOR_EN    1
#define LED_NUMs    9
#define SPEED       100
#define PIN_LED     3

const int __setR    = 0;
const int __setG    = 0;
const int __setB    = 255;

// class
JointV2 Joint;
stepper_4wd stepper(200);
Adafruit_NeoPixel strip = Adafruit_NeoPixel(LED_NUMs, PIN_LED, NEO_GRB + NEO_KHZ800);

void setRGB(int r, int g, int b)
{
    for(int i=0; i< strip.numPixels(); i++)
    {
        strip.setPixelColor(i, r, g, b);
    }
    strip.show();
}

void setup()
{
    Serial.begin(115200);
    strip.begin();
    strip.show(); // Initialize all pixels to 'off'
    Joint.begin();
    stepper.setSpeed(20, SPEED);
    Serial.println("sys start...");
    
    task_move();
}

void loop()
{
    btnProcess();
}

void btnProcess()
{
    if(Joint.readKey())
    {
        delay(20);
        if(Joint.readKey())
        {
            unsigned long timer_s = millis();
            while(Joint.readKey())
            {
                if(millis()-timer_s > 1000)
                {
                    Serial.println("power off");
                    Joint.pwrOff();
                }
            }

            static bool __Gflg_move = 1;
            __Gflg_move = 1-__Gflg_move;

            if(__Gflg_move)
            {
                task_move();
            }
            else
            {
                task_stop();
            }
        }
    }
}

bool isStop()
{
    if(Joint.readKey())
    {
        delay(5);
        if(Joint.readKey())
        {
            return 1;
        }
    }
    return 0;
}

void task_move()
{
    // add code here
    Serial.println("move");
    Joint.writeL(1);
    setRGB(__setR, __setG, __setB);
#if MOTOR_EN
    stepper.step(-30000);
#endif
}

void task_stop()
{
    // add code here
    Serial.println("stop");
    Joint.writeL(0);

    setRGB(0, 0, 0);
}
// END FILE